#!/bin/sh

###############################################################
#   This script should be hooked when invoking SYNOShareDelete()
#   Usable environment variable:
#       NITEMS, SHARE_NAME_X, SHARE_PATH_X, SHARE_OP_RESULT_X
###############################################################

#Include common scripts
. /var/packages/CloudStation/target/scripts/CloudStationCommon

#At begining, acquire package settings
PackageInfoGet;

SHARE_DEL_ACT="share del"
is_pkg_enable=0
is_homes_del=0

is_del_home()
{
	local idx=0;
    local cnt=1;
	local num=$(($NITEMS + 1));

	#Check if service share
	while [ "${cnt}" != "${num}" ]
	do
		eval "name=\$SHARE_NAME_$cnt"

		if [ "xhomes" = "x${name}" ]; then
			echo "1";
			return 1;
		fi

		cnt=$(($cnt + 1));
	done

	echo "0";
	return 0;
}

case $1 in
    --sdk-mod-ver)
	    #Print SDK support version
        echo "2.0";
    ;;
    --name)
        #Print package name
        echo ${CSTN_PKG_NAME};
    ;;
    --pkg-ver)
        #Print package version
        echo ${CSTN_PKG_VERSION};
    ;;
    --vendor)
        #Print package vendor
        echo ${CSTN_PKG_VENDOR};
    ;;
    --pre)
    
    	is_cstn_upgrade_process_done;    	
    	if [ 0 -eq $? ]; then
			exit 0;
        fi
        
		PackageEnableGet;
        if [ 1 -eq $? ]; then
			is_pkg_enable=1
        fi

		is_del_home;
		is_homes_del=$?

		if [ 1 -eq $is_homes_del ]; then
			logger -p 0 "homes deleted, remove path conf $CSTN_DB_PATH_DIR/$CSTN_DB_CONF"
			rm -rf "$CSTN_DB_PATH_DIR/$CSTN_DB_CONF"
		fi

        #Actions before share set
        local idx=0;
        local cnt=1;
        local num=$((NITEMS + 1));

        #Check if service share
        while [ "${cnt}" != "${num}" ]
        do
            eval "name=\$SHARE_NAME_$cnt"

            if [ "xhomes" = "x${name}"]; then
				continue;
            else
				${CSTN_USRCTL_BIN} -d 0 "@${name}" 0 1 > /dev/null 2>&1  
			fi

            cnt=$(($cnt + 1));
        done

        if [ 1 -eq $is_home_del -a 1 -eq $is_pkg_enable ]; then
	        #Stop service anyway
    	    ${CSTN_START_SCRIPT} stop > /dev/null 2>&1;
		fi
    ;;
    --post)
    
  		is_cstn_upgrade_process_done;    	
    	if [ 0 -eq $? ]; then
			exit 0;
        fi
        
		PackageEnableGet;
        if [ 0 -eq $? ]; then
			exit 0;
        fi
		
		#Actions before share set
        local idx=0;
        local cnt=1;
        local num=$(($NITEMS + 1));

        #Check if service share
        while [ "${cnt}" != "${num}" ]
        do
            eval "name=\$SHARE_NAME_$cnt"
            
			if [ "xhomes" = "x${name}"]; then
					idx=${cnt};
					break;
			fi

            cnt=$(($cnt + 1));
        done

        if [ "0" = "${idx}" ]; then
    	    return;
	    fi

		eval "ret=\$SHARE_OP_RESULT_$idx";
		if [ "0x0000" != "$ret" ]; then
			${CSTN_START_SCRIPT} start > /dev/null 2>&1;
		else
			touch "${CSTN_RELOAD_USERDB_CACHE_MARK}"
		fi
    ;;
    *)
        echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
    ;;
esac
