#!/bin/sh

###############################################################
#   This script should be hooked when invoking SYNOShareDelete()
#   Usable environment variable:
#       SHARE_NAME, ENC_ACTION={encrypt|decrypt}, RESULT
###############################################################

#Include common scripts
. /var/packages/CloudStation/target/scripts/CloudStationCommon

#At begining, acquire package settings
PackageInfoGet;

case $1 in
    --sdk-mod-ver)
	#Print SDK support version
        echo "2.0";
    ;;
    --name)
        #Print package name
        echo ${CSTN_PKG_NAME};
    ;;
    --pkg-ver)
        #Print package version
        echo ${CSTN_PKG_VERSION};
    ;;
    --vendor)
        #Print package vendor
        echo ${CSTN_PKG_VENDOR};
    ;;
    --pre)
    	is_cstn_upgrade_process_done;    	
    	if [ 0 -eq $? ]; then
			exit 0;
        fi
#		${CSTN_USRCTL_BIN} -s 0 "@${SHARE_NAME}" 0 1 > /dev/null 2>&1
#		following is temp solution, it should be removed when the issue that cgi locked smb_lock is resolved
		${CSTN_USRCTL_ENC_SHARE_BIN} "@${SHARE_NAME}"  > /dev/null 2>&1
	;;
    --post)
    	is_cstn_upgrade_process_done;    	
    	if [ 0 -eq $? ]; then
			exit 0;
        fi
        
		touch "${CSTN_RELOAD_USERDB_CACHE_MARK}"
    ;;
    *)
        echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
    ;;
esac
